import sys, os

#PYTHON_EGG_CACHE temporary files folder
os.environ['PYTHON_EGG_CACHE'] = '/tmp/'

#Adding the current project folder to the python path
#abspath = os.path.dirname(__file__)
#sys.path.append(abspath)
#os.chdir(abspath)

import web
from config import config 

#Declaring render templates
web.render = web.template.render(config.templates, base='layout')
web.render_ajax = web.template.render(config.templates)

#Connecting to database
web.db = web.database(host=config.database['host'], dbn=config.database['type'], user=config.database['user'], pw=config.database['password'], db=config.database['db'])

urls = (
'/', 'dashboard',
'/index','dashboard',

'/groups/', 'groups.groups',
'/groups/new', 'groups.new',
'/groups/update', 'groups.update',
'/groups/delete/(.*)', 'groups.delete',

'/hosts/', 'hosts.hosts',
'/hosts/new/(.*)', 'hosts.new',
'/hosts/update', 'hosts.update',
'/hosts/delete/(.*)', 'hosts.delete',
'/hosts/broker/(.*)', 'hosts.broker',

'/services/tunnel/(.*)', 'services.tunnel',
)

class dashboard:
    def GET(self):
        return web.render.dashboard(config.version)

if __name__ == '__main__':
	application = web.application(urls, globals())
	application.run()
else:
	application = web.application(urls, globals()).wsgifunc()

